---
title: StylePropertyMapReadOnly
slug: Web/API/StylePropertyMapReadOnly
tags:
  - API
  - CSS Typed Object Model API
  - Experimental
  - Houdini
  - Interface
  - Reference
  - StylePropertyMapReadOnly
---
<p>{{SeeCompatTable}}{{APIRef("CSS Typed Object Model API")}}</p>

<p>The <strong><code>StylePropertyMapReadOnly</code></strong> interface of the <a href="/en-US/docs/Web/API/CSS_Typed_Object_Model_API">CSS Typed Object Model API</a> provides a read-only representation of a CSS declaration block that is an alternative to {{domxref("CSSStyleDeclaration")}}. Retrieve an instance of this interface using {{domxref('Element.computedStyleMap','Element.computedStyleMap()')}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('StylePropertyMapReadOnly.size')}}</dt>
 <dd>Returns an unsinged long integer containing the size of the <code>StylePropertyMapReadOnly</code> object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref('StylePropertyMapReadOnly.entries()')}}</dt>
 <dd>Returns an array of a given object's own enumerable property <code>[key, value]</code> pairs, in the same order as that provided by a {{jsxref("Statements/for...in", "for...in")}} loop (the difference being that a for-in loop enumerates properties in the prototype chain as well).</dd>
 <dt>{{domxref('StylePropertyMapReadOnly.forEach()')}}</dt>
 <dd>Executes a provided function once for each element of <code>StylePropertyMapReadOnly</code>.</dd>
 <dt>{{domxref('StylePropertyMapReadOnly.get()')}}</dt>
 <dd>Returns the value of the specified property.</dd>
 <dt>{{domxref('StylePropertyMapReadOnly.getAll()')}}</dt>
 <dd>Returns an array of {{domxref("CSSStyleValue")}} objects containing the values for the provided property.</dd>
 <dt>{{domxref('StylePropertyMapReadOnly.has()')}}</dt>
 <dd>Indicates whether the specified property is in the <code>StylePropertyMapReadOnly</code> object.</dd>
 <dt>{{domxref('StylePropertyMapReadOnly.keys()')}}</dt>
 <dd>Returns a new Array Iterator containing the keys for each item in <code>StylePropertyMapReadOnly</code>.</dd>
 <dt>{{domxref('StylePropertyMapReadOnly.values()')}}</dt>
 <dd>Returns a new Array Iterator containing the values for each index in the <code>StylePropertyMapReadOnly</code> object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>We have to have an element to observe:</p>

<pre class="brush: html notranslate">&lt;p&gt;
   This is a paragraph with some text. We can add some CSS, or not. The
   style map will include all the default and inherted CSS property values.
&lt;/p&gt;
&lt;dl id="output"&gt;&lt;/dl&gt;</pre>

<p>We add a touch of CSS with a custom property to better demonstrate the output:</p>

<pre class="brush: css notranslate">p {
   --someVariable: 1.6em;
   --someOtherVariable: translateX(33vw);
   --anotherVariable: 42;
   line-height: var(--someVariable);
}</pre>

<p>We add JavaScript to grab our paragraph and return back a definition list of all the default CSS property values using {{domxref('Element.computedStyleMap()')}}.</p>

<pre class="brush: js notranslate">// get the element
const myElement = document.querySelector('p');

// get the &lt;dl&gt; we'll be populating
const stylesList = document.querySelector('#output');

// Retrieve all computed styles with computedStyleMap()
const stylePropertyMap = myElement.computedStyleMap();

// iterate thru the map of all the properties and values, adding a &lt;dt&gt; and &lt;dd&gt; for each
for (const [prop, val] of stylePropertyMap) {
	// properties
	const cssProperty = document.createElement('dt');
	cssProperty.innerText = prop;
	stylesList.appendChild(cssProperty);

	// values
	const cssValue = document.createElement('dd');
	cssValue.innerText = val;
	stylesList.appendChild(cssValue);
}</pre>

<p>{{EmbedLiveSample("Examples", 120, 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Typed OM','#stylepropertymapreadonly','StylePropertyMapReadOnly')}}</td>
   <td>{{Spec2('CSS Typed OM')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.StylePropertyMapReadOnly")}}</p>
